<p>Programirljive module dijelimo u tri velike porodice: jednostavne, složene te
   programirljiva logička polja.
</p>

<h3>Jednostavni programirljivi moduli</h3>

<p>Jednostavni programirljivi moduli (engl. <i>Simple Programmable Logic Devices</i>, 
   SPLD) povijesno su se pojavili kao najranija tehnologija koja je ponudila mogućnost 
   konfiguriranja jednostavnijih sklopova. Postoji nekoliko arhitektura ovih sklopova
   od kojih su dvije osnovne PLA i PAL:
</p>
<ul>
<li>Programirljivo logičko polje (engl. <i>Programmable Logic Array</i>, PLA) te</li>
<li>Poluprogramirljivo logičko polje (engl. <i>Programmable Array Logic</i>, PAL).</li>
</ul>
<p>Osnovna ideja ovih sklopova je korisniku ponuditi jednostavno ostvarivanje Booleovih
   funkcija u obliku sume produkata ili produkta suma.
</p>
<p>Jedna od često korištenih arhitektura je i GAL (engl. <i>Generic Array Logic</i> tvrtke
   Lattice) koja je slična PAL-u samo što još nudi i mogućnost pamćenja podataka u 
   integriranim bistabilima.
</p>

<p>Razmatramo li složenost funkcija koje je moguće ostvariti ovim modulima, dolazimo 
   do granice od par stotina osnovnih logičkih sklopova (odnosno funkcija koja je moguće
   ostvariti tom količinom sklopova).</p> 

<p>Da bi se korisnicima ponudila mogućnost izrade sve složenijeg sklopovlja, bilo bi
   potrebno izrađivati SPLD module sa sve više i više ulaza. No kako se povećanjem 
   broja ulaza kod pristupa koji slijede porodice PLA i PAL dolazi do potrebe za izradom 
   osnovnih logičkih sklopova koji imaju sve više ulaza a time kao posljedicu i sve veće 
   kašnjenje, izravno povećanje broja ulaza nakon određene granice više nije isplativo 
   jer bi rezultiralo sklopovima koji rade sporo.
</p>

<h3>Složeni programirljivi moduli</h3>

<p>Rješenje prethodnog problema pronađeno u novoj grani programirljivih sklopova naziva 
   CPLD. Ova porodica predstavlja programirljive module koji se sastoje od niza manjih 
   SPLD-ova oko kojih je provedeno programirljivo prospojno polje, i sve je smješteno na 
   jedan čip. Iako je takav oblik manje općenit od "velikog" SPLD-a koji bi imao jako puno 
   ulaza, u praksi je vrlo pogodan za uporabu, posebice u slučajevima kada je logičke 
   funkcije moguće dekomponirati u jednostavnije podfunkcije koje ostvaruju pojedini SPLD-ovi, i 
   čiji se rezultat brzim prospojnim poljem dovodi do novog SPLD-a koji ih kombinira u 
   složeniju funkciju. Dekompozicija u jednostavnije podfunkcije uobičajeno se automatski 
   obavlja uporabom prikladnih programskih alata na računalu.
</p>

<p>Razmatramo li složenost funkcija koje je moguće ostvariti ovim modulima, dolazimo 
   do granice od par stotina tisuća osnovnih logičkih sklopova (odnosno funkcija koja 
   je moguće ostvariti tom količinom sklopova).
</p> 

<h3>Programirljiva polja logičkih blokova</h3>

<p>Imamo li potrebu za ostvarivanjem još složenijih digitalnih sustava, tehnologija
   koja nam stoji na raspolaganju poznata je pod nazivom FPGA (engl. <i>Field
   Programmable Gate Array</i>), odnosno Programirljiva polja logičkih blokova.
</p>

<p>Kod ove porodice sklopova, osnovni programabilni element koji omogućava ostvarivanje
   Booleovih funkcija je konfigurabilni logički blok (engl. <i>Configurable Logic Block</i>,
   CLB) koji se najčešće temelji na k-bitnoj preglednoj tablici. Pregledna tablica 
   (engl. <i>Lookup Table</i>, LUT) konceptualno je multipleksor \(2^k\)-na-1 kod kojeg
   su adresni ulazi spojeni na ulaze konfigurabilnog logičkog bloka a korisnik može
   upisati na svaki od podatkovnih ulaza vrijednost 0 ili 1, čime izravno može ostvariti
   proizvoljnu Booleovu funkciju od <i>k</i> varijabli. Ovisno o porodici FPGA sklopova,
   <i>k</i> je uobičajeno između 4 i 6. Takvih konfigurabilnih logičkih blokova na čipu
   se može nalaziti ekstremno puno, a oni sami međusobno su povezani programirljivom
   prospojnom mrežom.
</p>
<p>Način ostvarivanja Booleovih funkcija ovdje je idejno sličan kao i kod CPLD-ova: složene
   funkcije potrebno je razložiti na jednostavnije koje je moguće ostvariti pojedinim
   konfigurabilnim logičkim blokovima i potom ih daljnjim konfigurabilnim logičkim 
   blokovima kombinirati. U modernim FPGA sklopovima, broj konfigurabilnih logičkih blokova
   prelazi stotine tisuća, a broj preglednih tablica koje je u njima moguće konfigurirati 
   može biti i veći od milijun (primjerice, kod FPGA modula Virtex-7 7V2000T tvrtke 
   Xilinx).
</p>







